PROGRAM matvec2
  IMPLICIT NONE
  INTEGER, PARAMETER :: n=1000
  INTEGER, PARAMETER :: prec = &
           SELECTED_REAL_KIND(12,100)
  INTEGER :: i, j, jk, n_proc
  REAL(KIND=prec), DIMENSION(n) :: vec, res=0.0_prec
  REAL(KIND=prec), DIMENSION(n,n) :: mat
  real*8 start, finish

  n_proc=1
  vec = 1.0_prec
  mat = 1.0_prec

  call cpu_time(start)

  DO jk = 1,1000 !loop esterno inserito solo per aumentare il tempo di calcolo
     DO i = 1,n
       DO j = 1,n
          res(i) = res(i) + mat(i,j) * vec(j)
       END DO
     END DO 
  ENDDO  

 call cpu_time(finish)
 
 print *,'TEMPI con ',n_proc,'processori: ',(finish-start)/n_proc 
  
END PROGRAM matvec2
