PROGRAM massimo
  IMPLICIT NONE
 
  INTEGER, PARAMETER :: N=100
  REAL, DIMENSION(N) :: a
  REAL :: locmax, maxvet, maxtemp
  INTEGER :: thread_id, num_threads, ifirst, ilast


  thread_id = omp_get_thread_num()
  num_threads = omp_get_num_threads()

  CALL mypart(ifirst,ilast,N,thread_id,num_threads)

  CALL init(a,N,ifirst,ilast,thread_id)
  
  CALL work(a,N,ifirst,ilast,locmax,thread_id)

!  PRINT *, 'ID= ',thread_id,' MAX  ',locmax

  maxvet = 0.



  maxvet = MAX(maxvet,locmax)
  PRINT *, 'ID= ',thread_id, ', LOCAL Result= ',maxvet

 
 
  PRINT *, 'ID= ',thread_id, ', MAX GLOBALE= ',maxvet


END PROGRAM massimo

SUBROUTINE mypart(ifi,ila,N,id,num)
  IMPLICIT NONE
  INTEGER :: ifi, ila, N, id, num

  ifi = N / num * id + 1
    
  IF ( id == num - 1 ) THEN
    ila = N
  ELSE
    ila = N / num * (id+1)
  END IF

END SUBROUTINE mypart

SUBROUTINE init(a,n,ifi,ila,id)
  IMPLICIT NONE
  INTEGER :: n
  REAL , DIMENSION(n) :: a
  INTEGER :: ifi, ila, i, id
    
 DO i = ifi, ila
  ! call RANDOM_NUMBER (a(ifi:ila))
     a(i)=ifi+i     
END DO

END SUBROUTINE init

SUBROUTINE work(a,n,ifi,ila,maxvet,id)
  IMPLICIT NONE
  INTEGER :: n
  REAL, DIMENSION(n) :: a
  REAL :: maxvet
  INTEGER :: ifi, ila, i, id
  
  maxvet = MAXVAL(a(ifi:ila))
  print*,'ID= ',id,', (',ifi,'-',ila,') max ', maxvet,', posiz= ',MAXLOC(a(ifi:ila))+ifi-1
 
END SUBROUTINE work



  

