PROGRAM maxRED
  IMPLICIT NONE
 
  INTEGER, PARAMETER :: N=100
  REAL, DIMENSION(N) :: a
  REAL :: locmax,maxvet,maxtemp
  INTEGER :: thread_id, num_threads,ifirst,ilast,i


  thread_id = omp_get_thread_num()
  num_threads = omp_get_num_threads()

  CALL mypart(ifirst,ilast,N,thread_id,num_threads)

  CALL init(a,N,ifirst,ilast,thread_id)
  
  maxvet = 0.

  DO i = 1, N  
    maxvet = MAX(maxvet,a(i))
! PRINT *, 'ciclo DO:ID= ',thread_id,'MAX=',maxvet 
  END DO

  PRINT *, 'ciclo DO:ID= ',thread_id,'MAX=',maxvet
 
 
  PRINT *, 'MAX=',maxvet
END PROGRAM maxRED

SUBROUTINE mypart(ifi,ila,N,id,num)
  IMPLICIT NONE
  INTEGER :: ifi,ila,N,id,num

  ifi = N / num * id + 1
    
  IF ( id == num-1 ) THEN
    ila = N
  ELSE
    ila = N / num * (id+1)
  END IF

END SUBROUTINE mypart

SUBROUTINE init(a,n,ifi,ila,id)
  IMPLICIT NONE
  INTEGER:: n
  REAL , DIMENSION(n):: a
  INTEGER:: ifi,ila,i,id
    
  DO i=ifi,ila
    ! call RANDOM_NUMBER (a(ifi:ila))
      a(i)=ifi+i     
 
  END DO

END SUBROUTINE init

