program calc_pi
      implicit none
      integer ::  i, threads, n
      real*8 :: w, x, sum, pi, f, a
      real*8 :: start, finish, timef
     
      f(a) = 4.0 / (1.0 + a*a)
      
      n = 100000000 
      call cpu_time(start)

      w = 1.0/n
      sum = 0.0

      do i = 1, n
         x = w * (i - 0.5)
         sum = sum + f(x)
      end do

      pi = w * sum

      call cpu_time(finish)

      print*, "value of pi, time taken:"
      print*, pi, (finish-start)/threads
      
      stop
      end

